function init(hero) {
    hero.setName("Vibe");
    hero.setAliases("vibe");
    hero.setTier(2);

    hero.setHelmet("Glasses");
    hero.setChestplate("item.superhero_armor.piece.jacket");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.shoes");

    hero.addPowers("secretheroes:dimensional_energy_manipulation");
    hero.addAttribute("FALL_RESISTANCE", 3.0, 0);
    hero.addAttribute("PUNCH_DAMAGE", 4.0, 0);
    hero.addAttribute("JUMP_HEIGHT", 0.5, 0);

    hero.addKeyBind("AIM", "key.aim", 1);
    hero.addKeyBind("CHARGED_BEAM", "Vibe Blasts", 2);
    hero.addKeyBind("TELEPORT", "key.teleport", 3);

    hero.addSoundEvent("AIM_START", ["secretheroes:vibe_aim_start", "secretheroes:vibe_aim_loop"]);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setHasProperty(hasProperty);
    hero.supplyFunction("canAim", canAim);
    hero.setKeyBindEnabled(isKeyBindEnabled);
}

function isModifierEnabled(entity, modifier) {
    switch (modifier.name()) {
    case "fiskheroes:charged_beam":
        return entity.getData('fiskheroes:aiming_timer') == 1;
    default:
        return true;
    }
}

function hasProperty(entity, property) {
    return property == "MASK_TOGGLE";
}

function canAim(entity) {
    return entity.getHeldItem().isEmpty();
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "CHARGED_BEAM":
        return entity.getData('fiskheroes:aiming_timer') == 1;
    case "TELEPORT":
        return entity.getData('fiskheroes:aiming_timer') == 1;
    default:
        return true;
    }
}
